Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jmx.support
Class MBeanServerFactoryBean

    java.lang.Object
      org.springframework.jmx.support.MBeanServerFactoryBean

All Implemented Interfaces:
  DisposableBean, FactoryBean<javax.management.MBeanServer>, InitializingBean

    public class MBeanServerFactoryBean

extends java.lang.Object
implements FactoryBean<javax.management.MBeanServer>, InitializingBean, DisposableBean

`FactoryBean` that obtains an `MBeanServer` reference through the standard JMX 1.2 `MBeanServerFactory` API (which is available on JDK 1.5 or as part of a JMX 1.2 provider). Exposes the `MBeanServer` for bean references.

By default, `MBeanServerFactoryBean` will always create a new `MBeanServer` even if one is already running. To have the `MBeanServerFactoryBean` attempt to locate a running `MBeanServer` first, set the value of the "locateExistingServerIfPossible" property to "true".

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  `setLocateExistingServerIfPossible(boolean)`, `locateMBeanServer(java.lang.String)`, `MBeanServer`, `MBeanServerFactory.findMBeanServer(java.lang.String)`, `MBeanServerFactory.createMBeanServer()`, `MBeanServerFactory.newMBeanServer()`, `MBeanServerConnectionFactoryBean`, `ConnectorServerFactoryBean`

Field Summary
`protected org.apache.commons.logging.Log` | `logger`

Constructor Summary
`MBeanServerFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Creates the `MBeanServer` instance.
`protected javax.management.MBeanServer` | `createMBeanServer(java.lang.String defaultDomain, boolean registerWithFactory)` Create a new `MBeanServer` instance and register it with the `MBeanServerFactory`, if desired.
`void` | `destroy()` Unregisters the `MBeanServer` instance, if necessary.
`javax.management.MBeanServer` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<? extends javax.management.MBeanServer>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`protected javax.management.MBeanServer` | `locateMBeanServer(java.lang.String agentId)` Attempt to locate an existing `MBeanServer`.
`void` | `setAgentId(java.lang.String agentId)` Set the agent id of the `MBeanServer` to locate.
`void` | `setDefaultDomain(java.lang.String defaultDomain)` Set the default domain to be used by the `MBeanServer`, to be passed to `MBeanServerFactory.createMBeanServer()` or `MBeanServerFactory.findMBeanServer()`.``
`void` | `setLocateExistingServerIfPossible(boolean locateExistingServerIfPossible)` Set whether or not the `MBeanServerFactoryBean` should attempt to locate a running `MBeanServer` before creating one.
`void` | `setRegisterWithFactory(boolean registerWithFactory)` Set whether to register the `MBeanServer` with the `MBeanServerFactory`, making it available through `MBeanServerFactory.findMBeanServer()`.``

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### logger

    protected final org.apache.commons.logging.Log logger

Constructor Detail

### MBeanServerFactoryBean

    public MBeanServerFactoryBean()

Method Detail

### setLocateExistingServerIfPossible

    public void setLocateExistingServerIfPossible(boolean locateExistingServerIfPossible)

  Set whether or not the `MBeanServerFactoryBean` should attempt to locate a running `MBeanServer` before creating one.

  Default is `false`.

### setAgentId

    public void setAgentId(java.lang.String agentId)

  Set the agent id of the `MBeanServer` to locate.

  Default is none. If specified, this will result in an automatic attempt being made to locate the attendant MBeanServer, and (importantly) if said MBeanServer cannot be located no attempt will be made to create a new MBeanServer (and an MBeanServerNotFoundException will be thrown at resolution time).

  Specifying the empty String indicates the platform MBeanServer.

  See Also:
    `MBeanServerFactory.findMBeanServer(String)`

### setDefaultDomain

    public void setDefaultDomain(java.lang.String defaultDomain)

  Set the default domain to be used by the `MBeanServer`, to be passed to `MBeanServerFactory.createMBeanServer()` or `MBeanServerFactory.findMBeanServer()`.

  Default is none.

  ``
  See Also:
    `MBeanServerFactory.createMBeanServer(String)`, `MBeanServerFactory.findMBeanServer(String)`

### setRegisterWithFactory

    public void setRegisterWithFactory(boolean registerWithFactory)

  Set whether to register the `MBeanServer` with the `MBeanServerFactory`, making it available through `MBeanServerFactory.findMBeanServer()`.

  ``
  See Also:
    `MBeanServerFactory.createMBeanServer()`, `MBeanServerFactory.findMBeanServer(java.lang.String)`

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws MBeanServerNotFoundException

  Creates the `MBeanServer` instance.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `MBeanServerNotFoundException`

### locateMBeanServer

    protected javax.management.MBeanServer locateMBeanServer(java.lang.String agentId)
                                                      throws MBeanServerNotFoundException

  Attempt to locate an existing `MBeanServer`. Called if `locateExistingServerIfPossible` is set to `true`.

  The default implementation attempts to find an `MBeanServer` using a standard lookup. Subclasses may override to add additional location logic.

  Parameters:
    `agentId` - the agent identifier of the MBeanServer to retrieve. If this parameter is `null`, all registered MBeanServers are considered.
  Returns:
    the `MBeanServer` if found
  Throws:
    `MBeanServerNotFoundException` - if no `MBeanServer` could be found
  See Also:
    `setLocateExistingServerIfPossible(boolean)`, `JmxUtils.locateMBeanServer(String)`, `MBeanServerFactory.findMBeanServer(String)`

### createMBeanServer

    protected javax.management.MBeanServer createMBeanServer(java.lang.String defaultDomain,
                                                             boolean registerWithFactory)

  Create a new `MBeanServer` instance and register it with the `MBeanServerFactory`, if desired.

  Parameters:
    `defaultDomain` - the default domain, or `null` if none
    `registerWithFactory` - whether to register the `MBeanServer` with the `MBeanServerFactory`
  See Also:
    `MBeanServerFactory.createMBeanServer()`, `MBeanServerFactory.newMBeanServer()`

### getObject

    public javax.management.MBeanServer getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<javax.management.MBeanServer>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<? extends javax.management.MBeanServer> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<javax.management.MBeanServer>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<javax.management.MBeanServer>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()

  Unregisters the `MBeanServer` instance, if necessary.

  Specified by:
    `destroy` in interface `DisposableBean`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD